#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name = "Extended Health",
	author = "The End Is Near..., wS / schmidt",
	version = "1.2",
	url = "http://clan.sn-team.ru/"
};

new	Handle:g_Use,
	Handle:g_HealThKit,
	Handle:g_Msg,
	Handle:g_MaxHp,
	Use[MAXPLAYERS+1],
	Handle:Welcome[MAXPLAYERS+1] = INVALID_HANDLE;

public OnPluginStart() 
{
	RegConsoleCmd("sm_kit", ShowMenu);
	RegConsoleCmd("sm_use", UseKit);
	RegConsoleCmd("sm_medic", UseKit);
	RegConsoleCmd("sm_medkit", UseKit);
	
	HookEvent("round_start", Event_OnRoundStart);
	
	g_Msg = CreateConVar("sm_kit_msg", "1", "Включение = 1 / Отключение = 0 показа сообщений", FCVAR_NOTIFY|FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	g_Use = CreateConVar("sm_kit_use", "1", "Укажите количество возможных использований аптечек", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	g_HealThKit = CreateConVar("sm_kit_hp", "25", "Укажите количество здоровья, даваемое за использование аптечки", FCVAR_NOTIFY|FCVAR_DONTRECORD);
	g_MaxHp = CreateConVar("sm_kit_max_hp", "100", "Укажите количество максимального здоровья у игрока", FCVAR_NOTIFY|FCVAR_DONTRECORD);
}

public OnClientPutInServer(client) 
{
	Use[client] = 0;
	Welcome[client] = CreateTimer(10.0, g_TimerMsg, client, TIMER_FLAG_NO_MAPCHANGE);
}

public OnClientDisconnect(client)
{
	if (Welcome[client] != INVALID_HANDLE)
	{
		KillTimer(Welcome[client]);
		Welcome[client] = INVALID_HANDLE;
	}
}

public Action:g_TimerMsg(Handle:timer, any:client)
{
	PrintToChat(client, "\x01\x05[SM] \x03Введите в чат \x05!kit \x03для получения информации об аптечки");
	Welcome[client] = INVALID_HANDLE;
}

public Event_OnRoundStart(Handle:event, const String:name[], bool:silent)
{
	for (new i = 1; i <= GetMaxClients(); i++)
	{
		if (IsClientInGame(i))
		{
			Use[i] = 0;
		}
	}
}

public Action:ShowMenu(client, args) 
{
	if (client != 0 && args < 1) 
	{
		new Handle:menu = CreateMenu(MenuHandler);
		SetMenuTitle(menu, "Информация по плагину");
		AddMenuItem(menu, "commands", "Доступные команды");
		AddMenuItem(menu, "info", "Информация о плагине");
		AddMenuItem(menu, "help", "Помощь по плагину");
		DisplayMenu(menu, client, 0);
	}
	return Plugin_Handled;		
}

public MenuHandler(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(menu);
		return;
	}
	else if (action == MenuAction_Select)
	{
		new String:get[32];
		GetMenuItem(menu, param2, get, sizeof(get));

		if (strcmp(get, "commands") == 0)
		{
			new Handle:panel = CreatePanel();
			SetPanelTitle(panel, "Доступные команды\n\n");
			DrawPanelText(panel, "!use\n!medic\n!kit\n!medkit");
			SendPanelToClient(panel, param1, panelka, 15);			
			CloseHandle(panel); 			
		}
		else if (strcmp(get, "info") == 0)
		{
			new Handle:info = CreatePanel();
			SetPanelTitle(info, "Информация о плагине\n");
			DrawPanelText(info, "Данный плагин позволяет, при вводе команды, получать дополнительное здоровье");
			SendPanelToClient(info, param1, panelka, 15);
			CloseHandle(info); 	
		}
		else if (strcmp(get, "help") == 0)
		{
			new Handle:help = CreateMenu(HelpHandler);
			SetMenuTitle(help, "Помомощь по плагину");
			AddMenuItem(help, "bind", "Как забиндить команды?");
			AddMenuItem(help, "hp", "Сколько аптечка добавляет здоровья?");
			AddMenuItem(help, "num", "Сколько раз можно пользоваться аптечкой?");
			DisplayMenu(help, param1, 0);	
		}
	}
}

public HelpHandler(Handle:help, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		CloseHandle(help);
		return;
	}
	else if (action == MenuAction_Select)
	{
		new String:helpi[32];
		GetMenuItem(help, param2, helpi, sizeof(helpi));

		if (strcmp(helpi, "bind") == 0)
		{
			new Handle:bind = CreatePanel();
			SetPanelTitle(bind, "Бинд команд");
			DrawPanelText(bind, "Для бинда команд напишите в консоли клиента следующее:\nbind key commands, где\nkey - Название клавишы\ncommands - Название команды");
			SendPanelToClient(bind, param1, panelka, 60);			
			CloseHandle(bind); 			
		}
		else if (strcmp(helpi, "hp") == 0)
		{
			new Handle:hp = CreatePanel();
			SetPanelTitle(hp, "Количество добавляемого здоровья");
			
			decl String:numihp[100];
			Format(numihp, sizeof(numihp), "На данный момент, аптечка добавляет %d", GetConVarInt(g_HealThKit));
			DrawPanelText(hp, numihp);
			SendPanelToClient(hp, param1, panelka, 15);
			CloseHandle(hp); 	
		}
		else if (strcmp(helpi, "num") == 0)
		{
			new Handle:num = CreatePanel();
			SetPanelTitle(num, "Количество возможных использований аптечек");
			
			decl String:numi[100];
			Format(numi, sizeof(numi), "На данный момент, использовать аптечку разрешено %d раз", GetConVarInt(g_Use));
			DrawPanelText(num, numi);
			SendPanelToClient(num, param1, panelka, 15);
			CloseHandle(num); 	
		}
	}
}

public panelka(Handle:menu, MenuAction:action, param1, param2)
{
	// Handler
}

public Action:UseKit(client, args)
{
	if (client != 0 && args < 1)
	{
		new hp = GetClientHealth(client);
		new mhp = GetConVarInt(g_MaxHp);
		new kit = GetConVarInt(g_HealThKit);
		if (!IsPlayerAlive(client))
		{
			if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Использование аптечки, когда вы мертвы, запрещено!");
			return Plugin_Handled;
		}		
		if (GetClientTeam(client) == 1)
		{
			if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Использование аптечки, когда вы в наблюдении, запрещено!");
			return Plugin_Handled;
		}
		if (hp >= mhp)
		{
			if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Использование аптечки, когда достигнуто максимальное количество здоровья, запрещено!");
			return Plugin_Handled;
		}
		if (Use[client] >= GetConVarInt(g_Use))
		{
			if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Использование аптечки, когда лимит вышел, запрещено!");
			return Plugin_Handled;
		}
		if (hp + kit >= mhp)
		{
			Use[client]++;
			if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Аптечка успешно использована!");
			SetEntityHealth(client, mhp);
			return Plugin_Handled;
		}
		Use[client]++;
		if (GetConVarBool(g_Msg)) PrintToChat(client, "\x01\x05[SM] \x03Аптечка успешно использована!");
		SetEntityHealth(client, hp + kit);
		return Plugin_Handled;		
	}
	return Plugin_Handled;
}